<?xml version="1.0" encoding="UTF-8"?>
<!--
1.6 WBISRVR/ws/code/bsm.tools/eclipse/plugins/com.ibm.wbis.statemachine.deployment/src/com/ibm/wbis/statemachine/deployment/mapping.sacl2bpel.xsl, WAS.adaptive.entity, WBIX.WBISRVR 12/12/05 15:57:42

IBM Confidential
OCO Source Material
5724-L01
(C) COPYRIGHT International Business Machines Corp. 2005
The source code for this program is not published or otherwise divested
of its trade secrets, irrespective of what has been deposited with the
U.S. Copyright Office.

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns="http://schemas.xmlsoap.org/ws/2004/03/business-process/"
    xmlns:wpc="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"
    xmlns:wsdl="http://www.ibm.com/xmlns/prod/websphere/scdl/wsdl/v6.0.0/"
    xmlns:sacl="http://www.ibm.com/xmlns/prod/websphere/wbi/sacl/6.0.0"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:xalan="http://xml.apache.org/xalan"
    xmlns:genutil="http://xml.apache.org/xalan/java/com.ibm.wbis.statemachine.deployment.BSMXSLHelper"
    extension-element-prefixes="genutil"
    xmlns:bpeltranslator="javaext/com.ibm.wbis.statemachine.deployment.BPELTranslator"
    xmlns:deploymentpkg="javaext/com.ibm.wbis.statemachine.deployment">

    <xsl:output method="xml" indent="yes"/>

	<xsl:key name="events" match="sacl:operation" use="concat(@portType, concat('.', @name))"/>
	<xsl:key name="trans" match="sacl:transition" use="concat(sacl:operation/@portType, concat('.', sacl:operation/@name))"/>
	<xsl:key name="compositeState" match="sacl:compositeState" use="@name"/>
	<xsl:key name="simpleState" match="sacl:state" use="@name"/>
	
	<!-- debug id generator -->
	<xsl:variable name="bpeltranslator" select="bpeltranslator:getBPELTranslator()"/>
	<xsl:variable name="bsmxslhelper" select="deploymentpkg:getBSMXSLHelper($bpeltranslator)"/>
	
	<xsl:template match="/">
	<xsl:variable name="nl"><xsl:text>
	</xsl:text></xsl:variable>
		<xsl:variable name="stateMachineName">
			<xsl:value-of select="*/@name"/>	
		</xsl:variable>	
		
		<xsl:variable name="stateMachineTargetNamespace">
			<xsl:value-of select="*/@targetNamespace"/>	
		</xsl:variable>	

        <genutil:trace message="=============== S T A T E   M A C H I N E   (" select="concat($stateMachineName, ')   ==============')"/>

		<!-- Process header -->
		<process targetNamespace="{$stateMachineTargetNamespace}">		
			<xsl:attribute name="name">
				<xsl:value-of select="$stateMachineName"/>
			</xsl:attribute>
			<xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
			<xsl:attribute name="suppressJoinFailure">no</xsl:attribute>
			<xsl:if test="sacl:stateMachineDefinition/@validFrom">
				<xsl:attribute name="validFrom" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="sacl:stateMachineDefinition/@validFrom"/></xsl:attribute>
			</xsl:if>
			
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
				<xsl:attribute name="name">generatedBy</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:text>BusinessStateMachine</xsl:text>
				</xsl:element>
			</xsl:element>
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
				<xsl:attribute name="name">name</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:value-of select="sacl:stateMachineDefinition/@name"/>
				</xsl:element>
			</xsl:element>			
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">			
				<xsl:attribute name="name">targetNameSpace</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:value-of select="$stateMachineTargetNamespace"/>
				</xsl:element>
			</xsl:element>			
			<xsl:if test="sacl:stateMachineDefinition/@validFrom">
				<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:attribute name="name">validFrom</xsl:attribute>
					<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
						<xsl:value-of select="sacl:stateMachineDefinition/@validFrom"/>
					</xsl:element>
				</xsl:element>
			</xsl:if>
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">			
				<xsl:attribute name="name">generatorVersion</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:text>6.0.1.003</xsl:text>
				</xsl:element>
			</xsl:element>
			<xsl:element name="customProperty" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">			
				<xsl:attribute name="name">buildVersion</xsl:attribute>
				<xsl:element name="value" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">1 6</xsl:element>
			</xsl:element>
			
			<!-- java globals -->
			<xsl:if test="//sacl:javaGlobals/sacl:import">
				<xsl:element name="javaGlobals" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:for-each select="//sacl:javaGlobals/sacl:import">
						<xsl:element name="import" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
							<xsl:attribute name="packages"><xsl:value-of select="@packages"/></xsl:attribute>
						</xsl:element>
					</xsl:for-each>	
				</xsl:element>
			</xsl:if>
			
			<!-- Partner links -->
			<xsl:value-of select="$nl"/><xsl:comment>Partner link definitions</xsl:comment><xsl:value-of select="$nl"/>
			<xsl:element name="partnerLinks">
				<!-- Defined interfaces / references -->
				<xsl:apply-templates select="*/sacl:interfaces/sacl:interface"/>
				<xsl:apply-templates select="*/sacl:references/sacl:reference"/>
			</xsl:element>
			
            <genutil:trace message="Variable definitions"/>

			<!-- Variables -->
			<xsl:value-of select="$nl"/><xsl:comment>Variable definitions</xsl:comment><xsl:value-of select="$nl"/>
			<xsl:element name="variables">
				<!-- State variables -->
				<xsl:element name="variable">
				   		<xsl:attribute name="name">ActState</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>				
				<xsl:element name="variable">
				   		<xsl:attribute name="name">DisplayState</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>				
				<xsl:element name="variable">
				   		<xsl:attribute name="name">ActTrans</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>
				<xsl:element name="variable">
				   		<xsl:attribute name="name">NxtState</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>
				<xsl:element name="variable">
				   		<xsl:attribute name="name">NxtDisplayState</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>
				<xsl:element name="variable">
				   		<xsl:attribute name="name">NxtTrans</xsl:attribute>
						<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>
				<xsl:element name="variable">
				   		<xsl:attribute name="name">SkipEntry</xsl:attribute>
						<xsl:attribute name="type">xsd:boolean</xsl:attribute>
				</xsl:element>
				<xsl:element name="variable">
				   		<xsl:attribute name="name">GuardValue</xsl:attribute>
						<xsl:attribute name="type">xsd:boolean</xsl:attribute>
				</xsl:element>
				<xsl:element name="variable">
					<xsl:attribute name="name">RuntimeFailureData</xsl:attribute>
					<xsl:attribute name="type">artifacts:runtimeFailureType</xsl:attribute>
				</xsl:element>                   
				<xsl:element name="variable">
					<xsl:attribute name="name">TransitionFailure</xsl:attribute>
					<xsl:attribute name="type">xsd:string</xsl:attribute>
				</xsl:element>				

				<!-- Timer variables -->
				<xsl:for-each select="//sacl:transition/sacl:duration">
					<xsl:element name="variable">
						<xsl:attribute name="name">
							<xsl:value-of select="@name"/><xsl:text>TimerValue</xsl:text>
						</xsl:attribute>
						<!-- <xsl:attribute name="messageType">wsdl:TimeMessage</xsl:attribute> -->						
						<xsl:attribute name="type">xsd:string</xsl:attribute>
					</xsl:element>
				</xsl:for-each>
				<xsl:for-each select="//sacl:transition/sacl:expiration">
					<xsl:element name="variable">
						<xsl:attribute name="name">
							<xsl:value-of select="@name"/><xsl:text>TimerValue</xsl:text>
						</xsl:attribute>
						<!-- <xsl:attribute name="messageType">wsdl:TimeMessage</xsl:attribute> -->
						<xsl:attribute name="type">xsd:string</xsl:attribute>						
					</xsl:element>
				</xsl:for-each>

				<!-- Event message variables -->
				<xsl:apply-templates select="//sacl:transition/sacl:operation" mode="variable"/>
				<xsl:apply-templates select="//sacl:variables/sacl:variable" mode="variable"/>
				
				<!-- input output variables when the management port type exists -->
				<xsl:if test="deploymentpkg:status-query-port-exists($bsmxslhelper)">
					<xsl:variable name="event">
						<xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/>
						<xsl:text>.getState</xsl:text>
					</xsl:variable>
					<xsl:element name="variable">
						<xsl:attribute name="name">getStateRequest</xsl:attribute>
						<xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/></xsl:attribute>
					</xsl:element>
					<xsl:element name="variable">
						<xsl:attribute name="name">getStateResponse</xsl:attribute>
						<xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:output-type($bsmxslhelper,$event)"/></xsl:attribute>
					</xsl:element>
				</xsl:if>

                <!-- input output variables when the display state port type exists -->
                <xsl:if test="deploymentpkg:display-status-query-port-exists($bsmxslhelper)">
                    <xsl:variable name="event">
                        <xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/>
                        <xsl:text>.getDisplayState</xsl:text>
                    </xsl:variable>
                    <xsl:element name="variable">
                        <xsl:attribute name="name">getDisplayStateRequest</xsl:attribute>
                        <xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/></xsl:attribute>
                    </xsl:element>
                    <xsl:element name="variable">
                        <xsl:attribute name="name">getDisplayStateResponse</xsl:attribute>
                        <xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:output-type($bsmxslhelper,$event)"/></xsl:attribute>
                    </xsl:element>
                </xsl:if>

			</xsl:element>

			<!-- Correlation sets -->
			<xsl:value-of select="$nl"/><xsl:comment>Correlation set definitions</xsl:comment><xsl:value-of select="$nl"/>
			<xsl:element name="correlationSets">
				<xsl:for-each select="*/sacl:correlationSet">
					<xsl:element name="correlationSet">
				   		<xsl:attribute name="name">
							<xsl:value-of select="@name"/>
						</xsl:attribute>
						<xsl:attribute name="properties">
							<xsl:variable name="properties"><xsl:value-of select="@properties"/></xsl:variable>
							<xsl:value-of select="deploymentpkg:convert-namespace-prefix-for-properties($bsmxslhelper,$properties)"/>
						</xsl:attribute>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>
	
			<!-- event handlers -->
			<xsl:if test="deploymentpkg:status-query-port-exists($bsmxslhelper) or deploymentpkg:display-status-query-port-exists($bsmxslhelper)">
				<xsl:element name="eventHandlers">
                    <xsl:if test="deploymentpkg:status-query-port-exists($bsmxslhelper)">
                        <genutil:trace message="getState"/>
                        <xsl:variable name="portType"><xsl:value-of select="deploymentpkg:status-query-port-type($bsmxslhelper)"/></xsl:variable>
                        <xsl:variable name="event">
                            <xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/>
                            <xsl:text>.getState</xsl:text>
                        </xsl:variable>
						<xsl:element name="onEvent">
							<xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="operation">getState</xsl:attribute>
							<xsl:attribute name="variable">getStateRequest</xsl:attribute>
							<xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/></xsl:attribute>
							<xsl:element name="correlations">
								<xsl:element name="correlation">
									<xsl:attribute name="initiate">no</xsl:attribute>
									<xsl:attribute name="set">
										<xsl:value-of select="/*/sacl:correlationSet/@name"/>
									</xsl:attribute>
								</xsl:element>
							</xsl:element>
							<xsl:element name="sequence">
								<xsl:element name="assign">
									<xsl:attribute name="name">GetStateAssign</xsl:attribute>
									<xsl:element name="copy">
										<xsl:element name="from">
											<xsl:attribute name="variable">ActState</xsl:attribute>
										</xsl:element>
										<xsl:element name="to">
											<xsl:attribute name="variable">getStateResponse</xsl:attribute>
											<xsl:attribute name="part"><xsl:value-of select="deploymentpkg:get-first-part-in-output($bsmxslhelper,$event)"/></xsl:attribute>
											<xsl:element name="query">
												<xsl:attribute name="queryLanguage">http://www.w3.org/TR/1999/REC-xpath-19991116</xsl:attribute>
												<xsl:text>/state</xsl:text>
											</xsl:element>
										</xsl:element>
									</xsl:element>
								</xsl:element>
								<xsl:element name="reply">
									<xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
									<xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
									<xsl:attribute name="operation">getState</xsl:attribute>
									<xsl:attribute name="variable">getStateResponse</xsl:attribute>
								</xsl:element>							
							</xsl:element>
						</xsl:element>
                    </xsl:if>
                    <xsl:if test="deploymentpkg:display-status-query-port-exists($bsmxslhelper)">
                        <genutil:trace message="getDisplayState"/>
                        <xsl:variable name="portType"><xsl:value-of select="deploymentpkg:display-status-query-port-type($bsmxslhelper)"/></xsl:variable>
                        <xsl:variable name="event">
                            <xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/>
                            <xsl:text>.getDisplayState</xsl:text>
                        </xsl:variable>
						<xsl:element name="onEvent">
							<xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:display-status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
							<xsl:attribute name="operation">getDisplayState</xsl:attribute>
							<xsl:attribute name="variable">getDisplayStateRequest</xsl:attribute>
							<xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/></xsl:attribute>
							<xsl:element name="correlations">
								<xsl:element name="correlation">
									<xsl:attribute name="initiate">no</xsl:attribute>
									<xsl:attribute name="set">
										<xsl:value-of select="/*/sacl:correlationSet/@name"/>
									</xsl:attribute>
								</xsl:element>
							</xsl:element>
							<xsl:element name="sequence">
								<xsl:element name="assign">
									<xsl:attribute name="name">GetDisplayStateAssign</xsl:attribute>
									<xsl:element name="copy">
										<xsl:element name="from">
											<xsl:attribute name="variable">DisplayState</xsl:attribute>
										</xsl:element>
										<xsl:element name="to">
											<xsl:attribute name="variable">getDisplayStateResponse</xsl:attribute>
											<xsl:attribute name="part"><xsl:value-of select="deploymentpkg:get-first-part-in-output($bsmxslhelper,$event)"/></xsl:attribute>
											<xsl:element name="query">
												<xsl:attribute name="queryLanguage">http://www.w3.org/TR/1999/REC-xpath-19991116</xsl:attribute>
												<xsl:text>/state</xsl:text>
											</xsl:element>
										</xsl:element>
									</xsl:element>
								</xsl:element>
								<xsl:element name="reply">
									<xsl:attribute name="partnerLink"><xsl:value-of select="deploymentpkg:display-status-query-partner-name($bsmxslhelper)"/></xsl:attribute>
									<xsl:attribute name="portType"><xsl:value-of select="deploymentpkg:display-status-query-port-type-qname($bsmxslhelper)"/></xsl:attribute>
									<xsl:attribute name="operation">getDisplayState</xsl:attribute>
									<xsl:attribute name="variable">getDisplayStateResponse</xsl:attribute>
								</xsl:element>							
							</xsl:element>
						</xsl:element>
                    </xsl:if>
				</xsl:element>
			</xsl:if>

			<!-- Activity -->
			<xsl:value-of select="$nl"/><xsl:comment>Activity definitions</xsl:comment><xsl:value-of select="$nl"/>

            <genutil:trace message="Main Sequence"/>

			<xsl:element name="sequence">
				<xsl:attribute name="name">MainSequence</xsl:attribute>				
				<xsl:attribute name="wpc:displayName">Type=com.ibm.wbi.SACL6.0 Version=6.0</xsl:attribute>
				<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">0</xsl:attribute>
				<xsl:apply-templates select="*/sacl:mainStateMachine/sacl:initialState" mode="init"/>
			</xsl:element>
		</process>
	</xsl:template>
	
	<xsl:template match="sacl:variable" mode="variable">
		<xsl:element name="variable">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
		</xsl:element>
	</xsl:template>

	<!-- Add event message variables -->
	<xsl:template match="sacl:operation" mode = "variable">
		<genutil:trace message="Event Message Variables" select="."/>
		
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		
		<xsl:if test="generate-id(.)=generate-id(key('events', $event)[1])">
			<xsl:element name="variable">
				<xsl:attribute name="name">
					<xsl:value-of select="@name"/><xsl:text>Request</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="messageType">
					<xsl:value-of select="deploymentpkg:input-type($bsmxslhelper,$event)"/>
				</xsl:attribute>
			</xsl:element>
			
			<xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event)/part">
				<genutil:trace message="name" select="@name"/>
				<genutil:trace message="type" select="@type"/>
				<xsl:element name="variable">
					<xsl:attribute name="name">
						<xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/>
					</xsl:attribute>
					<xsl:attribute name="type">
						<xsl:value-of select="@type"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:for-each>

			<xsl:if test="deploymentpkg:output-type($bsmxslhelper,$event)">
			<genutil:trace message="Two way operation, return variable will be defined" select="$event"/>
			<xsl:element name="variable">
				<xsl:attribute name="name">
					<xsl:value-of select="@name"/><xsl:text>Response</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="messageType">
					<xsl:value-of select="deploymentpkg:output-type($bsmxslhelper,$event)"/>
				</xsl:attribute>
			</xsl:element>
			</xsl:if>
			
			<xsl:for-each select="deploymentpkg:output-parts($bsmxslhelper,$event)/part">
				<genutil:trace message="name" select="@name"/>
				<genutil:trace message="type" select="@type"/>
				<xsl:element name="variable">
					<xsl:attribute name="name">
						<xsl:value-of select="@operation"/><xsl:text>_Output_</xsl:text><xsl:value-of select="@name"/>
					</xsl:attribute>
					<xsl:attribute name="type">
						<xsl:value-of select="@type"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:for-each>			
			
			<xsl:if test="deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
			<xsl:element name="variable">
				<xsl:attribute name="name">
					<xsl:value-of select="@name"/><xsl:text>BSMFaultVariable</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="messageType">
					<xsl:value-of select="deploymentpkg:getBSMFaultMessageQName($bsmxslhelper,$event)"/>
				</xsl:attribute>
			</xsl:element>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Add one partnerLink for each reference -->
	<xsl:template match="sacl:interface">
		<xsl:element name="partnerLink">
			<xsl:attribute name="name">
				<xsl:value-of select="substring-after(@portType,':')"/>
			</xsl:attribute>
			<xsl:attribute name="partnerLinkType">artifacts:<xsl:value-of select="substring-after(@portType,':')"/><xsl:text>PLT</xsl:text></xsl:attribute>
			<xsl:attribute name="myRole"><xsl:value-of select="substring-after(@portType,':')"/>Role</xsl:attribute>			
		</xsl:element>
	</xsl:template>

	<xsl:template match="sacl:reference">
		<xsl:for-each select="sacl:interface">
		<xsl:element name="partnerLink">
			<xsl:attribute name="name">
				<xsl:value-of select="../@name"/>
			</xsl:attribute>
			<xsl:attribute name="partnerLinkType">artifacts:<xsl:value-of select="../@name"/><xsl:text>PLT</xsl:text></xsl:attribute>
			<xsl:attribute name="partnerRole"><xsl:value-of select="substring-after(@portType,':')"/>Role</xsl:attribute>			
		</xsl:element>
		</xsl:for-each>
	</xsl:template>

	<!-- *** PROCESS STRUCTURE ******************************************** -->
	<xsl:template match="sacl:initialState" mode="init">
		<xsl:variable name="source" select="@name"/>
		<xsl:variable name="trans" select="../sacl:transition[sacl:sourceState = $source]"/>

		<xsl:variable name="initialDisplayName">
            <xsl:choose>
                <xsl:when test="string(@displayName)">
                    <xsl:value-of select="@displayName"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:text>undefined</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>

        <genutil:trace message="match=/ mode=init Initial state name=" select="concat(@name, concat(' display name=', $initialDisplayName))"/>

		<xsl:variable name="stateName">
            <xsl:choose>
                <xsl:when test="../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]">
                    <xsl:value-of select="../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]/sacl:initialState/@name"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$trans/sacl:targetState"/>
                </xsl:otherwise>
            </xsl:choose>
		</xsl:variable>

        <genutil:trace message="match=/ mode=init 2nd state=" select="$stateName"/>

		<xsl:variable name="nextDisplayName">
            <xsl:choose>
                <xsl:when test="../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]">
                    <genutil:trace message="match=/ mode=init 2nd state is a composite state"/>
                    <xsl:choose>
                        <xsl:when test="string(../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]/sacl:initialState/@displayName)">
                            <xsl:value-of select="../../sacl:compositeStateMachine[@name = $trans/sacl:targetState]/sacl:initialState/@displayName"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>undefined</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:when test="/*/*/sacl:state[@name = $trans/sacl:targetState]">
                    <genutil:trace message="match=/ mode=init 2nd state is a simple state"/>
                    <xsl:choose>
                        <xsl:when test="string(/*/*/sacl:state[@name = $trans/sacl:targetState]/@displayName)">
                            <xsl:value-of select="/*/*/sacl:state[@name = $trans/sacl:targetState]/@displayName"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>undefined</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:when test="/*/*/sacl:finalState[@name = $trans/sacl:targetState]">
                    <genutil:trace message="match=/ mode=init 2nd state is a final state"/>
                    <xsl:choose>
                        <xsl:when test="string(/*/*/sacl:finalState[@name = $trans/sacl:targetState]/@displayName)">
                            <xsl:value-of select="/*/*/sacl:finalState[@name = $trans/sacl:targetState]/@displayName"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>undefined</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:when test="/*/*/sacl:terminateState[@name = $trans/sacl:targetState]">
                    <genutil:trace message="match=/ mode=init 2nd state is a terminate state"/>
                    <xsl:choose>
                        <xsl:when test="string(/*/*/sacl:terminateState[@name = $trans/sacl:targetState]/@displayName)">
                            <xsl:value-of select="/*/*/sacl:terminateState[@name = $trans/sacl:targetState]/@displayName"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:text>undefined</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                    <genutil:trace message="match=/ mode=init 2nd state is an unknown state type"/>
                    <xsl:text>undefined</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
		</xsl:variable>

        <genutil:trace message="match=/ mode=init 2nd state display name=" select="$nextDisplayName"/>
		
        <xsl:variable name="event">
			<xsl:value-of select="$trans/sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$trans/sacl:operation/@name"/>
		</xsl:variable>

		<!-- Process instantiation -->
		<xsl:element name="receive">
			<xsl:attribute name="name">
				<xsl:text>Receive</xsl:text><xsl:value-of select="$trans/sacl:operation/@name"/>
			</xsl:attribute>
 			<xsl:attribute name="createInstance">yes</xsl:attribute>
			<xsl:attribute name="partnerLink">
				<xsl:value-of select="substring-after($trans/sacl:operation/@portType,':')"/>
			</xsl:attribute>
			<xsl:attribute name="portType"><xsl:value-of select="$trans/sacl:operation/@portType"/></xsl:attribute>
			<xsl:attribute name="operation"><xsl:value-of select="$trans/sacl:operation/@name"/></xsl:attribute>
			<!-- debug source SourceType is Start
							  SourceID is @name -->
			<xsl:variable name="debugSourceId" select="@name"/>
			<xsl:attribute name="wpc:displayName">
				<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=START</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
			<!-- end debug -->	
			<xsl:element name="correlations">
				<xsl:element name="correlation">
					<xsl:attribute name="initiate">yes</xsl:attribute>
					<xsl:attribute name="set">
						<xsl:value-of select="/*/sacl:correlationSet/@name"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
				<xsl:apply-templates select="$trans/sacl:operation" mode="addWpcInputParamters"/>
			</xsl:element>
		</xsl:element>
		
		<!-- notify runtime that process is initializing -->
		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.receivedInitializingMessage(this,"<xsl:value-of select="substring-after($trans/sacl:operation/@portType,':')"/>","<xsl:value-of select="$trans/sacl:operation/@name"/>",new Object[]{
			<xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event)/part">
				<xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/>
				<xsl:if test="position()&lt;last()">
					<xsl:text>,</xsl:text>
				</xsl:if>	
			</xsl:for-each>});
			</xsl:with-param>
		</xsl:call-template>

		<!-- StateEvent: Before initial state assignment -->
		<!-- Variable initialization -->
		<xsl:element name="assign">
			<xsl:attribute name="name">SetStateVariables</xsl:attribute>
			<xsl:element name="copy">
				<xsl:element name="from"><xsl:value-of select="$source"/></xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">ActState</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name="copy">
				<xsl:element name="from"><xsl:value-of select="$initialDisplayName"/></xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">DisplayState</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name="copy">
				<xsl:element name="from"><xsl:value-of select="$trans/@name"/></xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">ActTrans</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name="copy">
				<xsl:element name="from"><xsl:value-of select="$stateName"/></xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">NxtState</xsl:attribute>
					<xsl:attribute name="part">value</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name="copy">
				<xsl:element name="from"><xsl:value-of select="$nextDisplayName"/></xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">NxtDisplayState</xsl:attribute>
					<xsl:attribute name="part">value</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:element name="copy">
				<xsl:element name="from"><xsl:value-of select="$trans/@name"/></xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">NxtTrans</xsl:attribute>
				</xsl:element>
			</xsl:element>			
			<xsl:element name="copy">
				<xsl:element name="from">false</xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable">SkipEntry</xsl:attribute>
					<xsl:attribute name="part">value</xsl:attribute>
				</xsl:element>
			</xsl:element>
			<xsl:for-each select="//sacl:transition/sacl:duration">
			<xsl:element name="copy">
				<xsl:element name="from">252981792000000</xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable"><xsl:value-of select="@name"/><xsl:text>TimerValue</xsl:text></xsl:attribute>
				</xsl:element>				
			</xsl:element>							
			</xsl:for-each>
			<xsl:for-each select="//sacl:transition/sacl:expiration">
			<xsl:element name="copy">
				<xsl:element name="from">252981792000000</xsl:element>
				<xsl:element name="to">
					<xsl:attribute name="variable"><xsl:value-of select="@name"/><xsl:text>TimerValue</xsl:text></xsl:attribute>
				</xsl:element>				
			</xsl:element>							
			</xsl:for-each>
		</xsl:element>
		
		<!-- StateEvent: After initial state assignment -->
		
		<!-- Main process structure -->	
		<xsl:element name="while">
			<xsl:attribute name="name">MainWhileLoop</xsl:attribute>
			<!-- Build loop condition -->
			<xsl:variable name="first" select="../sacl:finalState[position()=1]/@name"/>
			<xsl:call-template name="addCondition">
				<xsl:with-param name="cond">
					<xsl:text>return (!ActState.equals("</xsl:text>
					<xsl:value-of select="$first"/>
					<xsl:for-each select="../sacl:finalState[@name!=$first]">
						<xsl:text>") &amp;&amp; !ActState.equals("</xsl:text><xsl:value-of select="@name"/>
					</xsl:for-each>
					<xsl:text>"));</xsl:text>
				</xsl:with-param>
			</xsl:call-template>

			<!-- Build loop structure -->
				<xsl:element name="scope">
                    <xsl:attribute name="name">WhileLoopScope</xsl:attribute>
					<xsl:element name="faultHandlers">
						<xsl:element name="catchAll">
							<xsl:element name="assign">
								<xsl:attribute name="name">ResetStateVariables</xsl:attribute>
								<xsl:element name="copy">
									<xsl:element name="from">undef</xsl:element>
									<xsl:element name="to">
										<xsl:attribute name="variable">NxtState</xsl:attribute>
									</xsl:element>
								</xsl:element>
								<xsl:element name="copy">
									<xsl:element name="from">undef</xsl:element>
									<xsl:element name="to">
										<xsl:attribute name="variable">NxtTrans</xsl:attribute>
									</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:element>
					</xsl:element>
					<xsl:element name="sequence">
                        <xsl:attribute name="name">WhileLoopScopeSequence</xsl:attribute>

                        <genutil:trace message="=========================== Transition Selection ==========================="/>

						<!-- Select automatic transitions -->
						<xsl:element name="switch">
                            <xsl:attribute name="name">TransitionSelection</xsl:attribute>
							<xsl:element name="case">
								<xsl:call-template name="addCondition">
									<xsl:with-param name="cond">
										<xsl:text>return ((NxtTrans == null) || (NxtTrans.equals("undef")));</xsl:text>
									</xsl:with-param>
								</xsl:call-template>
								<xsl:element name="sequence">
									<xsl:variable name="root" select="/*/sacl:mainStateMachine/sacl:initialState/@name"/>	
									<xsl:if test="/*/*/sacl:transition[sacl:automatic][sacl:sourceState!=$root]">
                                        <xsl:element name="switch">
                                            <xsl:attribute name="name">AutomaticTransitionsSwitchOnActState</xsl:attribute>
                                            <xsl:apply-templates select="/*/sacl:compositeStateMachine/sacl:initialState" mode="trans"/>
                                            <xsl:apply-templates select="/*/sacl:compositeStateMachine/sacl:finalState" mode="trans"/>
                                            <xsl:apply-templates select="/*/*/sacl:state" mode="trans"/>
                                        </xsl:element>
									</xsl:if>
									
									<!-- Select event driven transitions -->
									<xsl:if test="(count(/*/*/sacl:transition/sacl:operation) + count(/*/*/sacl:transition/sacl:duration) + count(/*/*/sacl:transition/sacl:expiration)) > 0">
										<xsl:element name="while">
											<xsl:attribute name="name">EventWhileLoop</xsl:attribute>
											<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
											<xsl:call-template name="addCondition">
												<xsl:with-param name="cond">
												<xsl:text>return (NxtTrans.equals("undef"));</xsl:text>
												</xsl:with-param>
											</xsl:call-template>
                                            <xsl:element name="sequence">
                                                <xsl:call-template name="ExecuteJavaCode">
                                                    <xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.enteringWaitState(this);</xsl:with-param>
                                                </xsl:call-template>
                                                <xsl:element name="pick">
                                                    <xsl:attribute name="name">PickEvents</xsl:attribute>
                                                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
                                                    <xsl:apply-templates select="/*/*/sacl:transition[sacl:operation]" mode="onMessage"/>
                                                    <xsl:apply-templates select="/*/*/sacl:transition[sacl:expiration|sacl:duration]" mode="onAlarm"/>
                                                </xsl:element>
                                            </xsl:element>
										</xsl:element>
									</xsl:if>
								</xsl:element>
							</xsl:element>						
						</xsl:element>

                        <genutil:trace message="=========================== Transition Selected ============================"/>
						
						<xsl:call-template name="ExecuteJavaCode">
							<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.transitionSelected(this,NxtTrans,ActState,NxtState);</xsl:with-param>
							<xsl:with-param name="elementName">TransitionSelected</xsl:with-param>
						</xsl:call-template>	

                        <genutil:trace message="=============================== Exit Actions ==============================="/>
						
						<!-- Arrange exit actions -->
						<xsl:if test="/*/*/*/sacl:exit">	
                            <xsl:element name="sequence">
                                <xsl:attribute name="name">ExitActions</xsl:attribute>
                                <xsl:apply-templates select="/*/*/sacl:state" mode="exit"/>
                                <xsl:apply-templates select="/*/*/sacl:compositeState" mode="exit"/>
							</xsl:element>						
						</xsl:if>

                        <genutil:trace message="===================== Transition Actions and Replies ======================="/>
						
						<!-- Arrange transition actions -->
						<xsl:element name="switch">
							<xsl:attribute name="name">TransitionActions</xsl:attribute>
							<xsl:apply-templates select="/*/*/sacl:transition" mode="select"/>
						</xsl:element>

                        <genutil:trace message="================================ Timer Reset ==============================="/>
						
						<!-- Arrange exit actions -->
						<xsl:if test="/*/*/*/sacl:duration or /*/*/*/sacl:expiration">	
                            <xsl:element name="sequence">
                                <xsl:attribute name="name">TimerResetActions</xsl:attribute>
                                <xsl:apply-templates select="/*/*/sacl:state" mode="timer"/>
                                <xsl:apply-templates select="/*/*/sacl:compositeState" mode="timer"/>
							</xsl:element>						
						</xsl:if>

                        <genutil:trace message="====================== Update ActState and DisplayState ===================="/>
						
						<!-- assign new state, unless this is a internal self transition -->
                        <xsl:element name="sequence">
                            <xsl:attribute name="name">StateChange</xsl:attribute>
                            <xsl:call-template name="ExecuteJavaCode">
                                <xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.stateChanging(this,ActState,NxtState);</xsl:with-param>
                            </xsl:call-template>
                            <xsl:element name="assign">
                                <xsl:element name="copy">
                                    <xsl:element name="from">
                                        <xsl:attribute name="variable">NxtState</xsl:attribute>
                                    </xsl:element>
                                    <xsl:element name="to">
                                        <xsl:attribute name="variable">ActState</xsl:attribute>
                                    </xsl:element>
                                </xsl:element>
                                <xsl:element name="copy">
                                    <xsl:element name="from">
                                        <xsl:attribute name="variable">NxtDisplayState</xsl:attribute>
                                    </xsl:element>
                                    <xsl:element name="to">
                                        <xsl:attribute name="variable">DisplayState</xsl:attribute>
                                    </xsl:element>
                                </xsl:element>
                            </xsl:element>
                        </xsl:element>

                        <genutil:trace message="============================ Debug Requirement ============================="/>

						<!-- create a debugger stopping point for the second state -->
						<xsl:element name="switch">
							<xsl:attribute name="name">DebugRequirement</xsl:attribute>
							<xsl:element name="case">
                                <xsl:call-template name="addCondition">
                                    <xsl:with-param name="cond">
                                        <xsl:text>return ActState.equals("</xsl:text>
                                        <xsl:value-of select="$stateName"/>
                                        <xsl:text>");</xsl:text>
                                    </xsl:with-param>
                                </xsl:call-template>
								<xsl:element name="empty">
                                    <xsl:variable name="debugSourceId" select="$stateName"/>
                                    <xsl:attribute name="wpc:displayName">
                                        <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=START</xsl:text>
                                    </xsl:attribute>
                                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
								</xsl:element>
							</xsl:element>
						</xsl:element>

                        <genutil:trace message="============= Update NxtTrans and Reset NxtState and NxtTrans =============="/>
						
						<!-- reset other variables -->
						<xsl:element name="assign">
							<xsl:attribute name="name">UpdateVariables</xsl:attribute>
                            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">5000</xsl:attribute>
							<xsl:element name="copy">
								<xsl:element name="from">
									<xsl:attribute name="variable">NxtTrans</xsl:attribute>
								</xsl:element>
								<xsl:element name="to">
									<xsl:attribute name="variable">ActTrans</xsl:attribute>
								</xsl:element>
							</xsl:element>
							<xsl:element name="copy">
								<xsl:element name="from">undef</xsl:element>
								<xsl:element name="to">
									<xsl:attribute name="variable">NxtState</xsl:attribute>
								</xsl:element>
							</xsl:element>
							<xsl:element name="copy">
								<xsl:element name="from">undef</xsl:element>
								<xsl:element name="to">
									<xsl:attribute name="variable">NxtTrans</xsl:attribute>
								</xsl:element>
							</xsl:element>				
						</xsl:element>

                        <genutil:trace message="====================== Entry Actions and Timer Setting ====================="/>
						
						<!-- Arrange entry actions -->
						<xsl:if test="/*/*/*/sacl:entry | /*/*/sacl:terminateState| /*/*/sacl:transition/sacl:duration | /*/*/sacl:transition/sacl:expiration">	
							<xsl:element name="switch">
								<xsl:attribute name="name">EntryActionSwitchOnActState</xsl:attribute>
								<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
								<xsl:apply-templates select="/*/*/sacl:state" mode="entry"/>
								<xsl:apply-templates select="/*/*/sacl:compositeState" mode="entry"/>
								<xsl:apply-templates select="/*/*/sacl:finalState" mode="entry"/>								
								<xsl:apply-templates select="/*/*/sacl:terminateState" mode="entry"/>
								<xsl:call-template name="OtherwiseSetToFalse">
								<xsl:with-param name="variable">SkipEntry</xsl:with-param>
								</xsl:call-template>
							</xsl:element>
						</xsl:if>					
					</xsl:element>
				</xsl:element>
		</xsl:element>

		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.instanceEnding(this);</xsl:with-param>
		</xsl:call-template>

        <genutil:trace message="==============================  X S L T    E N D I N G   ===================================')"/>

	</xsl:template>
	
	<!-- Add a Java-style condition for case and while -->
	<xsl:template name="addCondition">
        <xsl:param name="cond" select="'return true;'"/>
		<xsl:element name="condition">
			<xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
			<xsl:value-of select="$cond"/>
		</xsl:element>
	</xsl:template>

	<!-- *** ENTRY ACTIONS ************************************************ -->

	<!-- Add a entry action for "normal" states -->
	<xsl:template match="sacl:state | sacl:finalState" mode="entry">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="timeout" select="../sacl:transition[sacl:sourceState = $state][sacl:duration|sacl:expiration]"/>
		<xsl:if test="sacl:entry|$timeout">
            <xsl:element name="case">
            <!-- Build case condition -->
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                        <xsl:text>return (ActState.equals("</xsl:text>
                        <xsl:value-of select="@name"/>
                        <xsl:text>") &amp;&amp; !SkipEntry.booleanValue());</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
				<!-- Add structure -->
				<xsl:choose>
					<xsl:when test="sacl:entry">
						<xsl:choose>
							<xsl:when test="$timeout">
								<xsl:element name="sequence">
									<xsl:apply-templates select="sacl:entry" mode="invoke"/>
                                    <xsl:apply-templates select="." mode="setTimer"/>
								</xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="sacl:entry" mode="invoke"/>
							</xsl:otherwise>	
						</xsl:choose>			
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="." mode="setTimer"/>
					</xsl:otherwise>	
				</xsl:choose>
            </xsl:element>
		</xsl:if>	
	</xsl:template>
	
	<!-- Add a entry action for composite states -->
	<xsl:template match="sacl:compositeState" mode="entry">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="timeout" select="../sacl:transition[sacl:sourceState = $state][sacl:duration|sacl:expiration]"/>
		<xsl:if test="sacl:entry|$timeout">
			<xsl:element name="case">
				<!-- Build case condition -->
				<xsl:call-template name="addCondition">
					<xsl:with-param name="cond">
						<xsl:text>return ((</xsl:text>
						<xsl:for-each select="../sacl:transition[sacl:targetState = $state]">
							<xsl:text>ActTrans.equals("</xsl:text><xsl:value-of select="./@name"/><xsl:text>")</xsl:text>
							<xsl:if test="position()&lt;last()">
								<xsl:text> || </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>) &amp;&amp; !SkipEntry.booleanValue());</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				<!-- Add structure -->
				<xsl:choose>
					<xsl:when test="sacl:entry">
						<xsl:choose>
							<xsl:when test="$timeout">
								<xsl:element name="sequence">
									<xsl:apply-templates select="sacl:entry" mode="invoke"/>
                                    <xsl:apply-templates select="." mode="setTimer"/>
								</xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="sacl:entry" mode="invoke"/>
							</xsl:otherwise>	
						</xsl:choose>			
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="." mode="setTimer"/>
					</xsl:otherwise>	
				</xsl:choose>
			</xsl:element>
		</xsl:if>	
	</xsl:template>
	
	<!-- Add a entry action for terminate states -->
	<xsl:template match="sacl:terminateState" mode="entry">
		<xsl:element name="case">
			<!-- Build case condition -->
			<xsl:call-template name="addCondition">
				<xsl:with-param name="cond">
					<xsl:text>return ActState.equals("</xsl:text>
					<xsl:value-of select="@name"/>
					<xsl:text>");</xsl:text>
				</xsl:with-param>
			</xsl:call-template>
            <xsl:element name="sequence">
                <xsl:choose>
                    <xsl:when test="sacl:entry">
                        <xsl:apply-templates select="sacl:entry" mode="invoke"/>
                    </xsl:when>
                </xsl:choose>  
                <xsl:call-template name="ExecuteJavaCode">
                    <xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.instanceEnding(this);</xsl:with-param> 
                </xsl:call-template>
                <xsl:element name="terminate">
                    <xsl:attribute name="name">
                        <xsl:value-of select="@name"/><xsl:text>.terminate</xsl:text>
                    </xsl:attribute>
                </xsl:element>
            </xsl:element>				
		</xsl:element>
	</xsl:template>	
	
	<!-- Set timer variables -->
	<xsl:template match="sacl:state|sacl:compositeState" mode="setTimer">
		<xsl:variable name="state" select="@name"/>
				
		<xsl:if test="../sacl:transition[sacl:sourceState = $state]/sacl:expiration or ../sacl:transition[sacl:sourceState = $state]/sacl:duration">
            <xsl:element name="invoke">
                <xsl:attribute name="name"><xsl:value-of select="@name"/><xsl:text>.setTimer</xsl:text></xsl:attribute>
                <xsl:attribute name="partnerLink">null</xsl:attribute>
                <xsl:attribute name="portType">wpc:null</xsl:attribute>
                <xsl:attribute name="operation">null</xsl:attribute>

                <xsl:variable name="debugSourceId" select="@name"/>
                <xsl:attribute name="wpc:displayName">
                    <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Timer</xsl:text>
                </xsl:attribute>
                <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>

                <xsl:variable name="code">
                    <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:expiration">
                        <xsl:choose>
                            <xsl:when test="sacl:value">
                                <xsl:text>
                                java.util.Calendar cal = java.util.Calendar.getInstance();				
                                cal.set(</xsl:text><xsl:value-of select="."/><xsl:text>);</xsl:text>
                                <xsl:value-of select="@name"/><xsl:text>TimerValue = String.valueOf(cal.getTime().getTime());</xsl:text>
                            </xsl:when>
                            <xsl:when test="sacl:javaCode">
                                <xsl:value-of select="@name"/><xsl:text>TimerValue = "0";</xsl:text>
                            </xsl:when>
                        </xsl:choose>
                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.timerSetting(this,"<xsl:value-of select="../@name"/>","<xsl:value-of select="sacl:value"/>");
                    </xsl:for-each>

                    <xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:duration">
                        <xsl:choose>
                            <xsl:when test="sacl:value">
                                <xsl:value-of select="@name"/>TimerValue = com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.evaluateDuration("<xsl:value-of select="sacl:value"/>");
                            </xsl:when>
                            <xsl:when test="sacl:javaCode">
                                <xsl:value-of select="@name"/><xsl:text>TimerValue = "0";</xsl:text>
                            </xsl:when>
                        </xsl:choose>
                        com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.timerSetting(this,"<xsl:value-of select="../@name"/>","<xsl:value-of select="sacl:value"/>");
                    </xsl:for-each>
                </xsl:variable>	

                <xsl:element name="wpc:script">
                    <wpc:javaCode>
                        <xsl:value-of select="$code"/>
                    </wpc:javaCode>
                </xsl:element>
            </xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- *** AUTOMATIC TRANSITIONS **************************************** -->

	<!-- Add a automatic transitions for "normal" states -->
	<xsl:template match="sacl:state" mode="trans">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:variable name="compState" select="/*/sacl:compositeStateMachine[@name=$trans/../@name]/@name"/>
		<xsl:variable name="event">
			<xsl:value-of select="$trans/sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$trans/sacl:operation/@name"/>
		</xsl:variable>
		<xsl:if test="$trans">
			<xsl:element name="case">
				<xsl:call-template name="addCondition">
					<xsl:with-param name="cond">
						<xsl:text>return ActState.equals("</xsl:text>
						<xsl:value-of select="$state"/>
						<xsl:text>");</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="addStateTransitionCheck">
					<xsl:with-param name="trans" select="$trans"/>
					<xsl:with-param name="pos" select="'1'"/>
					<xsl:with-param name="finalOtherwise">
						<xsl:choose>
							<!-- Actual state can be left by an event triggered transition -->
							<xsl:when test="/*/*/sacl:transition[sacl:sourceState=$state or sacl:sourceState=$compState][not(sacl:automatic)]">
							</xsl:when>
							<!-- Actual state is a deadlock -->
							<xsl:otherwise>
								<xsl:element name="throw">
									<xsl:attribute name="name">
										<xsl:value-of select="$state"/><xsl:text>Deadlock</xsl:text>
									</xsl:attribute>
									<xsl:attribute name="faultName">sacl:fault</xsl:attribute>
									<xsl:attribute name="faultVariable">TransitionFailure</xsl:attribute>
								</xsl:element>	
							</xsl:otherwise>
						</xsl:choose>
					</xsl:with-param>	
				</xsl:call-template>						
			</xsl:element>
		</xsl:if>
	</xsl:template>
	
	<!-- Add a automatic transitions for initial states (composites) -->
	<xsl:template match="sacl:initialState" mode="trans">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:choose>
			<xsl:when test="$trans">
				<genutil:trace message="Automatic transition is defined in the sacl from the composite initial state" select="$state"/>
				<xsl:call-template name="addSimpleAutoTrans">
					<xsl:with-param name="state" select="$state"/>
					<xsl:with-param name="trans" select="$trans"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<genutil:trace message="No automatic transition is defined in the sacl from the composite initial state" select="$state"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Add a automatic transitions for final states -->
	<xsl:template match="sacl:finalState" mode="trans">
		<xsl:variable name="state" select="../@name"/>
		<xsl:variable name="trans" select="/*/*/sacl:transition[sacl:automatic][sacl:sourceState=$state]"/>
		<xsl:if test="$trans">
			<xsl:call-template name="addSimpleAutoTrans">
				<xsl:with-param name="state" select="@name"/>
				<xsl:with-param name="trans" select="$trans"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<!-- Build automatic transition's structure for initial and final states -->
	<xsl:template name="addSimpleAutoTrans">
		<xsl:param name="state"/>
		<xsl:param name="trans"/>
		<xsl:element name="case">
			<!-- Build case condition -->
			<xsl:call-template name="addCondition">
				<xsl:with-param name="cond">
					<xsl:text>return ActState.equals("</xsl:text>
					<xsl:value-of select="$state"/>
					<xsl:text>");</xsl:text>
				</xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="addAssignSetNxt">
				<xsl:with-param name="actTrans" select="$trans"/>
			</xsl:call-template>						
		</xsl:element>					
	</xsl:template>		

	<!-- Otherwise branch in AutomaticTransitionsSwitchOnActState -->
	<xsl:template name="OtherwiseSetToFalse">
		<xsl:param name="variable"/>
		<xsl:element name="otherwise">
			<xsl:element name="assign">
				<xsl:attribute name="name">
					<xsl:text>SetToFalse</xsl:text><xsl:value-of select="$variable"/>
				</xsl:attribute>
				<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>
				<xsl:element name="copy">
					<xsl:element name="from"><xsl:value-of select="false()"/></xsl:element>
					<xsl:element name="to">
						<xsl:attribute name="variable">
							<xsl:value-of select="$variable"/>
						</xsl:attribute>
						<xsl:attribute name="part">value</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:element>
	</xsl:template>

	<!-- *** EVENT TRIGGERED BRANCHES ************************************* -->

	<!-- Build PickEvent's onMessage branch -->
	<xsl:template match="sacl:transition" mode="onMessage">
		<xsl:variable name="event">
			<xsl:value-of select="sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="sacl:operation/@name"/>
		</xsl:variable>
		<xsl:variable name="trans" select="."/>
		
		<xsl:if test="generate-id(sacl:operation)=generate-id(key('events', $event)[1])">
			<xsl:element name="onMessage">
				<xsl:attribute name="partnerLink">
					<xsl:value-of select="substring-after(sacl:operation/@portType,':')"/>
				</xsl:attribute>
				<xsl:attribute name="portType"><xsl:value-of select="sacl:operation/@portType"/></xsl:attribute>
				<xsl:attribute name="operation"><xsl:value-of select="sacl:operation/@name"/></xsl:attribute>
				<xsl:element name="correlations">
					<xsl:element name="correlation">
						<xsl:attribute name="initiate">no</xsl:attribute>
						<xsl:attribute name="set">
							<xsl:value-of select="/*/sacl:correlationSet/@name"/>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
				<xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
					<xsl:apply-templates select="sacl:operation" mode="addWpcInputParamters"/>
				</xsl:element>
                <xsl:element name="sequence">
                    <xsl:attribute name="name">InitializeResponseAndSwitchOnActState</xsl:attribute>
                    <xsl:call-template name="ExecuteJavaCode">
                        <xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.receivedMessage(this,"<xsl:value-of select="substring-after($trans/sacl:operation/@portType,':')"/>","<xsl:value-of select="$trans/sacl:operation/@name"/>",new Object[]{
                            <xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event)/part">
                                <xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/>
                                <xsl:if test="position()&lt;last()">
                                <xsl:text>,</xsl:text>
                                </xsl:if>
                            </xsl:for-each>});
                        </xsl:with-param>
                    </xsl:call-template>
                    <xsl:apply-templates select="sacl:operation" mode="switchOnActState"/>
                </xsl:element>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- Build SwitchOnActState for each event -->
	<xsl:template match="sacl:operation" mode="switchOnActState">
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
        <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nostate')"/></xsl:attribute>				
        <xsl:if test="key('trans', $event)[key('simpleState', sacl:sourceState)]">
            <xsl:if test="count(/*/*/sacl:state) &gt; 0">
                <xsl:element name="switch">
                    <xsl:attribute name="name">DoAnySimpleStatesAcceptTheEvent</xsl:attribute>
                    <!-- One case branch for each state accepting the current event -->
                    <xsl:apply-templates select="/*/*/sacl:state" mode="event">
                        <xsl:with-param name="operation" select="."/>
                    </xsl:apply-templates>
                </xsl:element>
            </xsl:if>
        </xsl:if>
        <xsl:if test="key('trans', $event)[key('compositeState', sacl:sourceState)]">
            <xsl:element name="switch">
                <xsl:attribute name="name">IfNoSimpleStateAcceptedTheEvent</xsl:attribute>
                <xsl:element name="case">
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">
                            <xsl:text>return NxtTrans.equals("undef");</xsl:text>
                        </xsl:with-param>
                    </xsl:call-template>
                    <xsl:apply-templates select="." mode="switchOnCompositeState"/>
                </xsl:element>						
            </xsl:element>
        </xsl:if>
        <xsl:element name="switch">
            <xsl:attribute name="name">WasTheEventAccepted</xsl:attribute>
            <xsl:element name="case">
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                        <xsl:text>return NxtTrans.equals("undef");</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
                <xsl:element name="sequence">
                    <xsl:apply-templates select="." mode="replyTo">
                        <xsl:with-param name="type" select="'Fault'"/>
                        <xsl:with-param name="FaultMessage" select="deploymentpkg:get-message($bsmxslhelper,'DeployCommand.NoSelectableTransition')"/>
                    </xsl:apply-templates>
                </xsl:element>
            </xsl:element>						
        </xsl:element>
	</xsl:template>	

	<xsl:template match="sacl:operation" mode="switchOnCompositeState">
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:element name="switch">
			<xsl:attribute name="name">DoAnyCompositeStatesAcceptTheEvent</xsl:attribute>
			<xsl:variable name="debugSourceId" select="@name"/>				
			<xsl:attribute name="wpc:displayName">
			<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Event</xsl:text></xsl:attribute>
			<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>			
			<xsl:apply-templates select="/*/*/sacl:compositeState" mode="event">
				<xsl:with-param name="operation" select="."/>
			</xsl:apply-templates>
		</xsl:element>
	</xsl:template>

	<!-- Build case branch for each "normal" state that can accept the current event -->
	<xsl:template match="sacl:state" mode="event">
		<xsl:param name="operation"/>
		<xsl:variable name="event">
			<xsl:value-of select="$operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$operation/@name"/>
		</xsl:variable>
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="key('trans', $event)[sacl:sourceState=$state]"/>		
		<xsl:if test="$trans">
			<xsl:element name="case">
				<xsl:call-template name="addCondition">
					<xsl:with-param name="cond">
						<xsl:text>return ActState.equals("</xsl:text>
						<xsl:value-of select="$state"/><xsl:text>");</xsl:text>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="addStateTransitionCheck">
					<xsl:with-param name="event" select="$event"/>
					<xsl:with-param name="trans" select="$trans"/>
					<xsl:with-param name="pos" select="'1'"/>
				</xsl:call-template>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- Build case branch for each composite state that can accept the current exception event -->
	<xsl:template match="sacl:compositeState" mode="event">
		<xsl:param name="operation"/>
		<xsl:variable name="event">
			<xsl:value-of select="$operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="$operation/@name"/>
		</xsl:variable>
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="trans" select="key('trans', $event)[sacl:sourceState=$state]"/>		
		<xsl:if test="$trans">
            <xsl:variable name="currentTran" select="$trans[position()=1]" />
            <xsl:element name="case">
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">return (com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(this,"<xsl:value-of select="$currentTran/@name"/>", ActState,"<xsl:value-of select="$currentTran/sacl:targetState"/>","<xsl:value-of select="$state"/>"));</xsl:with-param>
                </xsl:call-template>
                <xsl:call-template name="addStateTransitionCheck">
                    <xsl:with-param name="event" select="$event"/>
                    <xsl:with-param name="trans" select="$trans"/>
                    <xsl:with-param name="pos" select="'1'"/>
                </xsl:call-template>						
            </xsl:element>
		</xsl:if>
	</xsl:template>
	
	<!-- *** TIMER TRIGGERED BRANCHES ************************************* -->

	<!-- Build PickEvent's onAlarm branch -->
	<xsl:template match="sacl:transition" mode="onAlarm">
		<xsl:variable name="timer">
			<xsl:value-of select="sacl:duration/@name|sacl:expiration/@name"/>
		</xsl:variable>
		<xsl:element name="onAlarm">
			<xsl:choose>
				<xsl:when test="sacl:duration/sacl:javaCode">
					<xsl:element name="for">
						<xsl:attribute name="expressionLanguage"><xsl:text>http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:text></xsl:attribute>
						<xsl:variable name="debugSourceId" select="@name"/>
						<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Timer</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
						
                        <xsl:text>if ("0".equals(</xsl:text><xsl:value-of select="$timer"/><xsl:text>TimerValue))
                        {</xsl:text>
					       <xsl:value-of select="sacl:duration/sacl:javaCode"/><xsl:text>
                        }
                        else
                        {
                           return Integer.MAX_VALUE;
                        }</xsl:text>

					</xsl:element>
				</xsl:when>
				<xsl:when test="sacl:expiration/sacl:javaCode">
					<xsl:element name="until">
						<xsl:attribute name="expressionLanguage"><xsl:text>http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:text></xsl:attribute>
						<xsl:variable name="debugSourceId" select="@name"/>
						<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Timer</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>

                        <xsl:text>if ("0".equals(</xsl:text><xsl:value-of select="$timer"/><xsl:text>TimerValue))
                        {</xsl:text>
					       <xsl:value-of select="sacl:expiration/sacl:javaCode"/><xsl:text>
                        }
                        else
                        {
                           java.util.Calendar cal = java.util.Calendar.getInstance();
					       cal.setTime(new java.util.Date(252981792000000L));
                           return cal;
                        }</xsl:text>

					</xsl:element>
				</xsl:when>	
				<xsl:otherwise>
					<xsl:element name="until">
						<xsl:text>java.util.Calendar cal = java.util.Calendar.getInstance();
						cal.setTime(new java.util.Date(Long.parseLong(</xsl:text><xsl:value-of select="$timer"/><xsl:text>TimerValue)));
						return cal;</xsl:text>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>
            <xsl:element name="sequence">
                <xsl:element name="switch">
                    <xsl:attribute name="name">SwitchOnActStateFor<xsl:value-of select="./@name"/></xsl:attribute>
                    <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nondebugid')"/></xsl:attribute>
                    <xsl:apply-templates select="key('simpleState', sacl:sourceState)" mode="alarm">
                        <xsl:with-param name="trans" select="."/>
                    </xsl:apply-templates>
                    <xsl:apply-templates select="key('compositeState', sacl:sourceState)" mode="alarm">
                        <xsl:with-param name="trans" select="."/>
                    </xsl:apply-templates>
                </xsl:element>
                <xsl:element name="assign">
                    <xsl:element name="copy">
                        <xsl:element name="from">252981792000000</xsl:element>
                        <xsl:element name="to">
                            <xsl:if test="./sacl:expiration">
                                <xsl:attribute name="variable"><xsl:value-of select="./sacl:expiration/@name"/>TimerValue</xsl:attribute>
                            </xsl:if>
                            <xsl:if test="./sacl:duration">
                                <xsl:attribute name="variable"><xsl:value-of select="./sacl:duration/@name"/>TimerValue</xsl:attribute>
                            </xsl:if>			
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:element>
		</xsl:element>
	</xsl:template>

	<xsl:template match="sacl:state" mode="alarm">
		<xsl:param name="trans"/>
		<xsl:variable name="state" select="@name"/>
		<xsl:element name="case">
			<xsl:call-template name="addCondition">
				<xsl:with-param name="cond">
					<xsl:text>return ActState.equals("</xsl:text>
					<xsl:value-of select="$state"/>
					<xsl:text>");</xsl:text>
				</xsl:with-param>
			</xsl:call-template>
            <xsl:call-template name="addStateTransitionCheck">
                <xsl:with-param name="trans" select="$trans"/>
                <xsl:with-param name="pos" select="'1'"/>
            </xsl:call-template>
		</xsl:element>
	</xsl:template>

	<xsl:template match="sacl:compositeState" mode="alarm">
		<xsl:param name="trans"/>
		<xsl:variable name="state" select="@name"/>
		<xsl:element name="case">
            <xsl:call-template name="addCondition">
                <xsl:with-param name="cond">return (com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(this,"<xsl:value-of select="$trans/@name"/>", ActState,"<xsl:value-of select="$trans/sacl:targetState"/>","<xsl:value-of select="$state"/>"));</xsl:with-param>
            </xsl:call-template>
            <xsl:call-template name="addStateTransitionCheck">
                <xsl:with-param name="trans" select="$trans"/>
                <xsl:with-param name="pos" select="'1'"/>
            </xsl:call-template>
		</xsl:element>
	</xsl:template>
	
	<!-- Assign variables NxtState and NxtTrans -->
	<xsl:template name="addAssignSetNxt">
		<xsl:param name="actTrans"/>
		<xsl:param name="SkipEvent"/>
		
        <genutil:trace message="name=addAssignSetNxt active transition= " select="concat($actTrans/@name, concat(' source=', concat($actTrans/sacl:sourceState, concat(' target=', $actTrans/sacl:targetState))))"/>

        <xsl:element name="assign">

            <xsl:variable name="debugSourceId" select="$actTrans/sacl:targetState"/>
            <xsl:attribute name="wpc:displayName">
                <xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=START Tr=</xsl:text><xsl:value-of select="$actTrans/@name"/>
            </xsl:attribute>
            <xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
            <xsl:attribute name="name">SetNxtActTrans</xsl:attribute>

            <xsl:element name="copy">
                <xsl:element name="from">
                    <xsl:choose>
                        <xsl:when test="$actTrans/../../sacl:compositeStateMachine[./@name = $actTrans/sacl:targetState]">
                            <xsl:value-of select="$actTrans/../../sacl:compositeStateMachine[@name = $actTrans/sacl:targetState]/sacl:initialState/@name"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of select="$actTrans/sacl:targetState"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
                <xsl:element name="to">
                    <xsl:attribute name="variable">NxtState</xsl:attribute>
                    <xsl:attribute name="part">value</xsl:attribute>
                </xsl:element>
            </xsl:element>

            <xsl:element name="copy">
                <xsl:element name="from">
                    <xsl:choose>
                        <xsl:when test="$actTrans/../../sacl:compositeStateMachine[@name = $actTrans/sacl:targetState]">
                            <genutil:trace message="name=addAssignSetNxt target is a composite state "/>
                            <xsl:choose>
                                <xsl:when test="string($actTrans/../../sacl:compositeStateMachine[@name = $actTrans/sacl:targetState]/sacl:initialState/@displayName)">
                                    <xsl:value-of select="$actTrans/../../sacl:compositeStateMachine[@name = $actTrans/sacl:targetState]/sacl:initialState/@displayName"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:text>undefined</xsl:text>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:when test="$actTrans/../sacl:state[@name = $actTrans/sacl:targetState]">
                            <genutil:trace message="name=addAssignSetNxt target is a simple state "/>
                            <xsl:choose>
                                <xsl:when test="string($actTrans/../sacl:state[@name = $actTrans/sacl:targetState]/@displayName)">
                                    <xsl:value-of select="$actTrans/../sacl:state[@name = $actTrans/sacl:targetState]/@displayName"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:text>undefined</xsl:text>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:when test="$actTrans/../sacl:finalState[@name = $actTrans/sacl:targetState]">
                            <genutil:trace message="name=addAssignSetNxt target is a final state "/>
                            <xsl:choose>
                                <xsl:when test="string($actTrans/../sacl:finalState[@name = $actTrans/sacl:targetState]/@displayName)">
                                    <xsl:value-of select="$actTrans/../sacl:finalState[@name = $actTrans/sacl:targetState]/@displayName"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:text>undefined</xsl:text>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:when test="$actTrans/../sacl:terminateState[@name = $actTrans/sacl:targetState]">
                            <genutil:trace message="name=addAssignSetNxt target is a terminate state "/>
                            <xsl:choose>
                                <xsl:when test="string($actTrans/../sacl:terminateState[@name = $actTrans/sacl:targetState]/@displayName)">
                                    <xsl:value-of select="$actTrans/../sacl:terminateState[@name = $actTrans/sacl:targetState]/@displayName"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:text>undefined</xsl:text>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:otherwise>
                            <genutil:trace message="name=addAssignSetNxt target is an unknown state type "/>
                            <xsl:text>undefined</xsl:text>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
                <xsl:element name="to">
                    <xsl:attribute name="variable">NxtDisplayState</xsl:attribute>
                    <xsl:attribute name="part">value</xsl:attribute>
                </xsl:element>
            </xsl:element>

            <xsl:element name="copy">
                <xsl:element name="from"><xsl:value-of select="$actTrans/@name"/></xsl:element>
                <xsl:element name="to">
                    <xsl:attribute name="variable">NxtTrans</xsl:attribute>
                    <xsl:attribute name="part">value</xsl:attribute>
                </xsl:element>
            </xsl:element>

			<xsl:if test="$actTrans[sacl:sourceState=sacl:targetState][@internal='true']">
                <xsl:element name="copy">
                    <xsl:element name="from">true</xsl:element>
                    <xsl:element name="to">
                        <xsl:attribute name="variable">SkipEntry</xsl:attribute>
                        <xsl:attribute name="part">value</xsl:attribute>
                    </xsl:element>
                </xsl:element>
            </xsl:if>

            <xsl:if test="$SkipEvent">
                <xsl:copy-of select="$SkipEvent"/>
            </xsl:if>
        </xsl:element>
	</xsl:template>	
	
	<!-- *** EXIT ACTIONS ************************************************* -->

	<!-- Add a exit action for simple and composite states -->
	<xsl:template match="sacl:compositeState | sacl:state" mode="exit">
		<xsl:variable name="state" select="@name"/>
		<xsl:if test="sacl:exit">
            <xsl:element name="switch">
                <xsl:element name="case">
                    <!-- Build case condition -->
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">return (com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(this,NxtTrans,ActState,NxtState,"<xsl:value-of select="$state"/>") &amp;&amp; !SkipEntry.booleanValue());</xsl:with-param>
                    </xsl:call-template>
                    <!-- Add structure -->
                    <xsl:apply-templates select="sacl:exit" mode="invoke"/>
                </xsl:element>
            </xsl:element>
		</xsl:if>	
	</xsl:template>

	<xsl:template match="sacl:compositeState | sacl:state" mode="timer">
		<xsl:variable name="state" select="@name"/>
		<xsl:variable name="timeout" select="../sacl:transition[sacl:sourceState = $state][sacl:duration|sacl:expiration]"/>
		<xsl:if test="$timeout">
            <xsl:element name="switch">
                <xsl:element name="case">
                    <!-- Build case condition -->
                    <xsl:call-template name="addCondition">
                        <xsl:with-param name="cond">return (com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.executeExitAction(this,NxtTrans,ActState,NxtState,"<xsl:value-of select="$state"/>") &amp;&amp; !SkipEntry.booleanValue());</xsl:with-param>
                    </xsl:call-template>
                    <!-- Add structure -->
                    <xsl:apply-templates select="." mode="resetTimer"/>
                </xsl:element>
            </xsl:element>
		</xsl:if>	
	</xsl:template>

	<!-- *** TRANSITION'S ACTIONS ***************************************** -->

	<!-- Add transition's action for non-composite states -->
	<xsl:template match="sacl:transition" mode="select">
		<xsl:variable name="state" select="sacl:sourceState"/>
		<!-- Selecting transitions that start at non-composite state -->
		<xsl:if test="/*/*/sacl:initialState[@name=$state] | /*/*/sacl:state[@name=$state] | /*/sacl:compositeStateMachine/sacl:initialState[@name=$state] | /*/*/sacl:compositeState[@name=$state]">
			<xsl:apply-templates select="." mode="execute"/>
		</xsl:if>
	</xsl:template>

	<!-- Build transition's action's structure -->
	<xsl:template match="sacl:transition" mode="execute">
        <genutil:trace message="match=sacl:transition mode=execute transition name=" select="concat(@name, concat(' internal=', @internal))"/>
		<xsl:variable name="state" select="sacl:sourceState"/>
        <xsl:if test="sacl:operation or sacl:action">
            <genutil:trace message="match=sacl:transition mode=execute has operation and/or action"/>
            <xsl:element name="case">
                <!-- Build case condition -->
                <xsl:call-template name="addCondition">
                    <xsl:with-param name="cond">
                        <xsl:text>return NxtTrans.equals("</xsl:text>
                        <xsl:value-of select="@name"/>
                        <xsl:text>");</xsl:text>
                    </xsl:with-param>
                </xsl:call-template>
                <!-- Add structure -->
                <xsl:choose>
                    <xsl:when test="sacl:operation">
                        <xsl:element name="sequence">
                            <xsl:if test="sacl:action">
                                <xsl:apply-templates select="sacl:action" mode="invoke"/>
                            </xsl:if>
                            <xsl:apply-templates select="sacl:operation" mode="replyTo"/>
                        </xsl:element>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:apply-templates select="sacl:action" mode="invoke"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:element>
        </xsl:if>
	</xsl:template>

	<!-- *** TIMER RESETTING ********************************************** -->

	<!-- Reset timer after transition's action -->
	<xsl:template match="sacl:state|sacl:compositeState" mode="resetTimer">
		<xsl:variable name="state" select="@name"/>
		<xsl:if test="../sacl:transition[sacl:sourceState = $state][sacl:expiration|sacl:duration]">
		
			<xsl:element name="invoke">
				<xsl:attribute name="name">
					<xsl:value-of select="@name"/><xsl:text>.resetTimer</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="partnerLink">null</xsl:attribute>
				<xsl:attribute name="portType">wpc:null</xsl:attribute>
				<xsl:attribute name="operation">null</xsl:attribute>
				<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'nondebugid')"/></xsl:attribute>
				<xsl:variable name="code">
					<xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:expiration">
com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.timerUnsetting(this,"<xsl:value-of select="../@name"/>");
<xsl:text></xsl:text><xsl:value-of select="@name"/>
<xsl:text>TimerValue = "252981792000000";
</xsl:text>
			</xsl:for-each>
			<xsl:for-each select="../sacl:transition[sacl:sourceState = $state]/sacl:duration">
com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.timerUnsetting(this,"<xsl:value-of select="../@name"/>");
<xsl:text></xsl:text><xsl:value-of select="@name"/>
<xsl:text>TimerValue = "252981792000000";
</xsl:text>
					</xsl:for-each>
				</xsl:variable>		
				<xsl:element name="wpc:script">
					<wpc:javaCode>
						<xsl:value-of select="$code"/>
					</wpc:javaCode>
				</xsl:element>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- *** ACTION INVOCATION ******************************************** -->

	<xsl:template match="sacl:operation" mode="replyTo">
		<xsl:param name="type"/>
		<xsl:param name="FaultMessage"><xsl:value-of select="deploymentpkg:getMessage($bsmxslhelper,'DeployCommand.UnknownFailure')"/></xsl:param>
		<genutil:trace message="match=sacl:operation mode=replyTo " select="concat('name=', concat(@name, concat(' type=', concat($type, concat(' FaultMessage=', $FaultMessage)))))"/>
		
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>

        <xsl:choose>
            <xsl:when test="contains($type,'Fault') and deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                <genutil:trace message="match=sacl:operation mode=replyTo: operation hasBSMFault"/>
                <xsl:element name="assign">
                    <xsl:element name="copy">
                        <xsl:element name="from"><xsl:value-of select="$FaultMessage"/></xsl:element>
                        <xsl:element name="to">
                            <xsl:attribute name="variable"><xsl:value-of select="@name"/><xsl:text>BSMFaultVariable</xsl:text></xsl:attribute>
                            <xsl:attribute name="part"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
                <xsl:element name="reply">
                    <xsl:attribute name="name">
                        <xsl:text>Reply</xsl:text><xsl:value-of select="$type"/>
                        <xsl:text>To_</xsl:text><xsl:value-of select="@name"/>
                    </xsl:attribute>
                    <xsl:attribute name="partnerLink">
                        <xsl:value-of select="substring-after(@portType,':')"/>
                    </xsl:attribute>
                    <xsl:attribute name="portType"><xsl:value-of select="@portType"/></xsl:attribute>
                    <xsl:attribute name="operation"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:attribute name="faultName">
                        <xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/>
                    </xsl:attribute>
                    <xsl:attribute name="variable">
                        <xsl:value-of select="@name"/><xsl:text>BSMFaultVariable</xsl:text>
                    </xsl:attribute>
                </xsl:element>
            </xsl:when>
            <xsl:when test="deploymentpkg:is-two-way($bsmxslhelper,$event)">
                <genutil:trace message="match=sacl:operation mode=replyTo: operation isTwoWay"/>
                <xsl:call-template name="ExecuteJavaCode">
                <xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.sendingResponse(this,
                "<xsl:value-of select="substring-after(@portType,':')"/>","<xsl:value-of select="@name"/>",new Object[]{
                    <xsl:for-each select="deploymentpkg:output-parts($bsmxslhelper,$event)/part">
                        <xsl:value-of select="@operation"/><xsl:text>_Output_</xsl:text><xsl:value-of select="@name"/>
                        <xsl:if test="position()&lt;last()">
                            <xsl:text>,</xsl:text>
                        </xsl:if>
                    </xsl:for-each>});</xsl:with-param>
                </xsl:call-template>
                <xsl:element name="reply">
                    <xsl:attribute name="name">
                        <xsl:text>Reply</xsl:text><xsl:value-of select="$type"/>
                        <xsl:text>To_</xsl:text><xsl:value-of select="@name"/>
                    </xsl:attribute>
                    <xsl:attribute name="partnerLink">
                        <xsl:value-of select="substring-after(@portType,':')"/>
                    </xsl:attribute>
                    <xsl:attribute name="portType"><xsl:value-of select="@portType"/></xsl:attribute>
                    <xsl:attribute name="operation"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
                        <xsl:apply-templates select="." mode="addWpcOutputParameters"/>
                    </xsl:element>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <genutil:trace message="match=sacl:operation mode=replyTo: operation not(isTwoWay) and not(hasBSMFault)"/>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>

	<!-- *** ACTION INVOCATION ******************************************** -->
			
	<xsl:template match="sacl:operation" mode="addWpcInputParamters">
		<xsl:param name="variable"/>
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>

		<xsl:for-each select="deploymentpkg:input-parts($bsmxslhelper,$event)/part">
		<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="variable"><xsl:value-of select="@operation"/><xsl:text>_Input_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
		</xsl:element>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="sacl:operation" mode="addWpcOutputParameters">		
		<xsl:param name="variable"/>	
		<genutil:trace message="xsl:template match=sacl:operation mode=addWpcOutputParameters"/>		
		
		<xsl:variable name="event">
			<xsl:value-of select="@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="@name"/>
		</xsl:variable>

		<xsl:for-each select="deploymentpkg:output-parts($bsmxslhelper,$event)/part">
		<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="variable"><xsl:value-of select="@operation"/><xsl:text>_Output_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
		</xsl:element>
		</xsl:for-each>
	</xsl:template>
			
	<xsl:template name="ExecuteJavaCode">
		<xsl:param name="code"/>
        <xsl:param name="elementName"/>

		<xsl:element name="invoke">
            <xsl:if test="$elementName">
                <xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
            </xsl:if>
            <xsl:attribute name="partnerLink">null</xsl:attribute>
			<xsl:attribute name="portType">wpc:null</xsl:attribute>
			<xsl:attribute name="operation">null</xsl:attribute>
			<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,'theidkey')"/></xsl:attribute>
			<xsl:element name="wpc:script">
				<wpc:javaCode>
					<xsl:value-of select="$code"/>
				</wpc:javaCode>
			</xsl:element>
		</xsl:element>		
	</xsl:template>
	
	<xsl:template match="sacl:action | sacl:entry | sacl:exit" mode="invoke">
		<xsl:variable name="nodeType">
            <xsl:choose>
                <xsl:when test="local-name() = 'entry'">
                    <xsl:value-of select="'EntryAction'"/>
                </xsl:when>
                <xsl:when test="local-name() = 'exit'">
                    <xsl:value-of select="'ExitAction'"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'Action'"/>
                </xsl:otherwise>
            </xsl:choose>
		</xsl:variable>
		<xsl:variable name="operation" select="../sacl:operation"/>
		<xsl:variable name="event">
			<xsl:value-of select="../sacl:operation/@portType"/>
			<xsl:text>.</xsl:text>
			<xsl:value-of select="../sacl:operation/@name"/>
		</xsl:variable>
		<xsl:element name="scope">
			<xsl:if test="true()">
				<xsl:if test="deploymentpkg:hasBSMFault($bsmxslhelper,$event) or sacl:javaCode or deploymentpkg:faults($bsmxslhelper,sacl:invoke/@operation,sacl:invoke/@reference)/fault">
                    <xsl:element name="variables">
                        <!-- the return message variable -->
                        <xsl:if test="../sacl:operation and deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
                            <xsl:element name="variable">
                                <xsl:attribute name="name">BSMFaultReturnMessage</xsl:attribute>
                                <xsl:attribute name="messageType"><xsl:value-of select="deploymentpkg:getBSMFaultMessageQName($bsmxslhelper,$event)"/></xsl:attribute>
                            </xsl:element>
                        </xsl:if>
                        <!-- the caught java failure variable -->
                        <xsl:if test="sacl:javaCode">
                            <xsl:element name="variable">
                                <xsl:attribute name="name">JavaRuntimeFailureData</xsl:attribute>
                                <xsl:attribute name="type">artifacts:runtimeFailureType</xsl:attribute>
                            </xsl:element>
                        </xsl:if>
                        <!-- invoke failure variables -->
                        <xsl:for-each select="deploymentpkg:faults($bsmxslhelper,sacl:invoke/@operation,sacl:invoke/@reference)/fault">
                            <xsl:element name="variable">
                                <xsl:attribute name="name"><xsl:value-of select="@FaultName"/></xsl:attribute>
                                <xsl:attribute name="messageType"><xsl:value-of select="@MessageQName"/></xsl:attribute>
                            </xsl:element>
                        </xsl:for-each>
                    </xsl:element>
				</xsl:if>
			</xsl:if>
			<xsl:element name="faultHandlers">
				<xsl:element name="catchAll">
					<xsl:element name="sequence">
						<xsl:apply-templates select="." mode="ActionFault">
						</xsl:apply-templates>
						<xsl:if test="$operation">
                            <xsl:apply-templates select="../sacl:operation" mode="replyTo">
                                <xsl:with-param name="type" select="'Fault'"/>
                                <xsl:with-param name="FaultMessage" select="deploymentpkg:get-message($bsmxslhelper,'DeployCommand.UnknownExceptionSeeLog')"/>
                            </xsl:apply-templates>
                            <xsl:element name="throw">
                             <xsl:attribute name="name"><xsl:text>RethrowFault</xsl:text></xsl:attribute>
                             <xsl:attribute name="faultName">sacl:fault</xsl:attribute>
                             <xsl:attribute name="faultVariable">TransitionFailure</xsl:attribute>
                            </xsl:element>
						</xsl:if>
					</xsl:element>								
				</xsl:element>		
				<xsl:if test="sacl:javaCode">
					<xsl:element name="catch">
						<xsl:attribute name="faultName"><xsl:text>wpc:runtimeFailure</xsl:text></xsl:attribute>
						<xsl:attribute name="faultVariable">JavaRuntimeFailureData</xsl:attribute>
						<xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">artifacts:runtimeFailureType</xsl:attribute>
						<xsl:element name="sequence">
                            <xsl:apply-templates select="." mode="ActionFault">
                                <xsl:with-param name="FaultVariable">JavaRuntimeFailureData</xsl:with-param>
                            </xsl:apply-templates>								
							<xsl:choose>
								<xsl:when test="../sacl:operation and deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
									<!-- reply or reply with fault if two way -->
									<xsl:element name="assign">
										<xsl:element name="copy">
											<xsl:element name="from">JavaRuntimeFailureData</xsl:element>
											<xsl:element name="to">
												<xsl:attribute name="variable">BSMFaultReturnMessage</xsl:attribute>
												<xsl:attribute name="part"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
											</xsl:element>
										</xsl:element>
									</xsl:element>
									<xsl:element name="reply">
										<xsl:attribute name="partnerLink"><xsl:value-of select="substring-after(../sacl:operation/@portType,':')"/></xsl:attribute>
										<xsl:attribute name="portType"><xsl:value-of select="../sacl:operation/@portType"/></xsl:attribute>
										<xsl:attribute name="operation"><xsl:value-of select="../sacl:operation/@name"/></xsl:attribute>
										<xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/></xsl:attribute>
										<xsl:attribute name="variable">BSMFaultReturnMessage</xsl:attribute>
									</xsl:element>
								</xsl:when>
								<xsl:otherwise>
									<xsl:apply-templates select="../sacl:operation" mode="replyTo"/>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:if test="$operation">							
                                <xsl:element name="throw">
                                    <xsl:attribute name="name"><xsl:text>RethrowFault</xsl:text></xsl:attribute>
                                    <xsl:attribute name="faultName">sacl:fault</xsl:attribute>
                                    <xsl:attribute name="faultVariable">TransitionFailure</xsl:attribute>
                                </xsl:element>
				           	</xsl:if>
						</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="sacl:invoke">
					<xsl:variable name="invoke" select="sacl:invoke"/>
					<xsl:for-each select="deploymentpkg:faults($bsmxslhelper,sacl:invoke/@operation,sacl:invoke/@reference)/fault">
						<xsl:element name="catch">
							<xsl:attribute name="faultName"><xsl:value-of select="@FaultQName"/></xsl:attribute>
							<xsl:attribute name="faultVariable"><xsl:value-of select="@FaultName"/></xsl:attribute>
							<xsl:attribute name="faultMessageType"><xsl:value-of select="@MessageQName"/></xsl:attribute>
							<xsl:element name="sequence">
                                <xsl:apply-templates select="$invoke/.." mode="ActionFault">
                                    <xsl:with-param name="FaultVariable" select="@FaultName"/>
                                </xsl:apply-templates>									
								<xsl:choose>
									<xsl:when test="../sacl:operation and deploymentpkg:rethrowCompatible($bsmxslhelper,$event,@MessageQName)">
										<xsl:element name="reply">
											<xsl:attribute name="partnerLink"><xsl:value-of select="substring-after($invoke/../../sacl:operation/@portType,':')"/></xsl:attribute>
											<xsl:attribute name="portType"><xsl:value-of select="$invoke/../../sacl:operation/@portType"/></xsl:attribute>
											<xsl:attribute name="operation"><xsl:value-of select="$invoke/../../sacl:operation/@name"/></xsl:attribute>
											<xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getFaultQName($bsmxslhelper,$event,@MessageQName)"/></xsl:attribute>
											<xsl:attribute name="variable"><xsl:value-of select="@FaultName"/></xsl:attribute>
										</xsl:element>
									</xsl:when>
									<xsl:when test="../sacl:operation and deploymentpkg:hasBSMFault($bsmxslhelper,$event)">
										<xsl:element name="assign">
											<xsl:element name="copy">
												<xsl:element name="from"><xsl:value-of select="@FaultName"/></xsl:element>
												<xsl:element name="to">
													<xsl:attribute name="variable">BSMFaultReturnMessage</xsl:attribute>
													<xsl:attribute name="part"><xsl:value-of select="deploymentpkg:getBSMFaultPartName($bsmxslhelper,$event)"/></xsl:attribute>
												</xsl:element>
											</xsl:element>
										</xsl:element>
										<xsl:element name="reply">
											<xsl:attribute name="partnerLink"><xsl:value-of select="substring-after($invoke/../../sacl:operation/@portType,':')"/></xsl:attribute>
											<xsl:attribute name="portType"><xsl:value-of select="$invoke/../../sacl:operation/@portType"/></xsl:attribute>
											<xsl:attribute name="operation"><xsl:value-of select="$invoke/../../sacl:operation/@name"/></xsl:attribute>
											<xsl:attribute name="faultName"><xsl:value-of select="deploymentpkg:getBSMFaultQName($bsmxslhelper,$event)"/></xsl:attribute>
											<xsl:attribute name="variable">BSMFaultReturnMessage</xsl:attribute>
										</xsl:element>
									</xsl:when>
									<xsl:otherwise>
										<xsl:apply-templates select="$invoke/../../sacl:operation" mode="replyTo"/>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:if test="$operation">
                                    <xsl:element name="throw">
                                        <xsl:attribute name="name"><xsl:text>RethrowFault</xsl:text></xsl:attribute>
                                        <xsl:attribute name="faultName">sacl:fault</xsl:attribute>
                                        <xsl:attribute name="faultVariable">TransitionFailure</xsl:attribute>
                                    </xsl:element>
					            </xsl:if>
							</xsl:element>
						</xsl:element>
					</xsl:for-each>
				</xsl:if>
			</xsl:element>
			<xsl:element name="sequence">
				<xsl:call-template name="ActionPreInvoke"/>
				<xsl:element name="invoke">
					<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
					<xsl:if test="sacl:javaCode">
						<xsl:variable name="debugSourceId" select="../@name"/>
						<xsl:attribute name="wpc:displayName">
						<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=</xsl:text><xsl:value-of select="$nodeType"/></xsl:attribute>
						<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
						<xsl:attribute name="partnerLink">null</xsl:attribute>
						<xsl:attribute name="portType">wpc:null</xsl:attribute>
						<xsl:attribute name="operation">null</xsl:attribute>
						<xsl:element name="wpc:script">
							<wpc:javaCode>
								<xsl:value-of select="sacl:javaCode"/>
							</wpc:javaCode>
						</xsl:element>
					</xsl:if>
					<xsl:for-each select="sacl:invoke">
							<xsl:variable name="debugSourceId" select="../../@name"/>
							<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=</xsl:text><xsl:value-of select="$nodeType"/></xsl:attribute>
							<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
							<xsl:attribute name="partnerLink">
								<xsl:value-of select="@reference"/>
							</xsl:attribute>
							<xsl:attribute name="portType">
								<xsl:value-of select="deploymentpkg:resolve-port-type($bsmxslhelper,.)"/>
							</xsl:attribute>
							<xsl:attribute name="operation"><xsl:value-of select="@operation"/></xsl:attribute>
							<genutil:trace message="Adding invoke of external operation"/>
							<xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
								<xsl:for-each select="sacl:input">
									<xsl:for-each select="sacl:parameter">
										<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
											<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
											<xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
										</xsl:element>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:element>
							<xsl:if test="deploymentpkg:is-two-way($bsmxslhelper,@reference,@operation)">
								<xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
									<xsl:for-each select="sacl:output">
										<xsl:for-each select="sacl:parameter">
											<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
												<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
												<xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
											</xsl:element>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:element>			
							</xsl:if>
					</xsl:for-each>
				</xsl:element>
				<xsl:call-template name="ActionPostInvoke"/>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<xsl:template name="ActionPreInvoke">
		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionPreinvoke(this,"<xsl:value-of select="@name"/>");</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template name="ActionPostInvoke">
		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionPostinvoke(this,"<xsl:value-of select="@name"/>");</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template match="sacl:action | sacl:entry | sacl:exit" mode="ActionFault">
		<xsl:param name="FaultVariable">"unavailable"</xsl:param>
		<xsl:call-template name="ExecuteJavaCode">
			<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.actionFailure(this,"<xsl:value-of select="@name"/>",<xsl:value-of select="$FaultVariable"/>);</xsl:with-param>
		</xsl:call-template>
	</xsl:template>

	<!--
		Generates the guard check sequence for the first guard in the list, then
		calls itself to generate the next.
	-->
	<xsl:template name="addStateTransitionCheck">
		<!-- the node list of guards -->
		<xsl:param name="trans"/>
		<xsl:param name="finalOtherwise"/>
		<xsl:param name="pos" select="'1'"/>
				
		<xsl:param name="transitions" select="$trans"/>
		<xsl:param name="index" select="$pos"/>
		
		<xsl:variable name="transition" select="$transitions[position()=$index]"/>		
		
		<xsl:comment>Guard check for transition <xsl:value-of select="$transition/@name"/></xsl:comment>
		
		<xsl:choose>
		<!-- unguarded transition -->
			<xsl:when test="$index='1' and count($transition/sacl:guard) = 0">
						<xsl:call-template name="addAssignSetNxt">
                            <xsl:with-param name="actTrans" select="$transition"/>
						</xsl:call-template>				
			</xsl:when>
			<xsl:otherwise>
		<!-- the transition that the first guard in the list belongs to -->
		<xsl:element name="sequence">
            <xsl:if test="$index='1'">
                <xsl:element name="assign">
                    <xsl:element name="copy">
                        <xsl:element name="from">false</xsl:element>
                        <xsl:element name="to">
                            <xsl:attribute name="variable">GuardValue</xsl:attribute>
                        </xsl:element>
                    </xsl:element>
                </xsl:element>
            </xsl:if>
			<xsl:element name="scope">
				<xsl:if test="($transition/sacl:guard/sacl:invoke and (count(deploymentpkg:faults($bsmxslhelper,$transition/sacl:guard/sacl:invoke/@operation,$transition/sacl:guard/sacl:invoke/@reference)/fault) > 0)) or $transition/sacl:guard/sacl:javaCode">
				<xsl:element name="variables">
					<xsl:if test="$transition/sacl:guard/sacl:javaCode">
						<xsl:element name="variable">
							<xsl:attribute name="name">JavaRuntimeFailureData</xsl:attribute>
							<xsl:attribute name="type">artifacts:runtimeFailureType</xsl:attribute>
						</xsl:element>
					</xsl:if>
					<xsl:for-each select="deploymentpkg:faults($bsmxslhelper,$transition/sacl:guard/sacl:invoke/@operation,$transition/sacl:guard/sacl:invoke/@reference)/fault">
						<xsl:element name="variable">
							<xsl:attribute name="name"><xsl:value-of select="@FaultName"/></xsl:attribute>
							<xsl:attribute name="messageType"><xsl:value-of select="@MessageQName"/></xsl:attribute>
						</xsl:element>
					</xsl:for-each>
				</xsl:element>
				</xsl:if>
				<xsl:element name="faultHandlers">
				<xsl:element name="catchAll">
					<xsl:call-template name="ExecuteJavaCode">
						<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",null);
						</xsl:with-param>
					</xsl:call-template>
				</xsl:element>
				<xsl:if test="$transition/sacl:guard/sacl:javaCode">
					<xsl:element name="catch">
						<xsl:attribute name="faultName"><xsl:text>wpc:runtimeFailure</xsl:text></xsl:attribute>
						<xsl:attribute name="faultVariable">JavaRuntimeFailureData</xsl:attribute>
						<xsl:attribute name="faultType" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">artifacts:runtimeFailureType</xsl:attribute>
						<xsl:element name="sequence">
							<xsl:call-template name="ExecuteJavaCode">
								<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",JavaRuntimeFailureData);
								</xsl:with-param>
							</xsl:call-template>
						</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="$transition/sacl:guard/sacl:invoke">
					<xsl:variable name="invoke" select="$transition/sacl:guard/sacl:invoke"/>
					<xsl:for-each select="deploymentpkg:faults($bsmxslhelper,$invoke/@operation,$invoke/@reference)/fault">
						<xsl:element name="catch">
							<xsl:attribute name="faultName"><xsl:value-of select="@FaultQName"/></xsl:attribute>
							<xsl:attribute name="faultVariable"><xsl:value-of select="@FaultName"/></xsl:attribute>
							<xsl:attribute name="faultMessageType"><xsl:value-of select="@MessageQName"/></xsl:attribute>
							<xsl:element name="sequence">
								<xsl:call-template name="ExecuteJavaCode">
									<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardFailure(this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",<xsl:value-of select="@FaultName"/>);
									</xsl:with-param>
								</xsl:call-template>
							</xsl:element>
						</xsl:element>
					</xsl:for-each>
				</xsl:if>
				</xsl:element>
				<xsl:element name="sequence">
					<xsl:call-template name="ExecuteJavaCode">
						<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPreinvoke(this,"<xsl:value-of select="$transition/sacl:guard/@name"/>");</xsl:with-param>
					</xsl:call-template>				
					<xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
						<xsl:element name="switch">
							<xsl:variable name="debugSourceId" select="../../@name"/>
							<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
							<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
							<xsl:element name="case">
								<xsl:element name="condition">
									<xsl:attribute name="expressionLanguage">http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/</xsl:attribute>
									<xsl:for-each select="$transition/sacl:guard/sacl:javaCode">
										<xsl:value-of select="."/>
									</xsl:for-each>
								</xsl:element>
								<xsl:element name="assign">
									<xsl:element name="copy">
										<xsl:element name="from">true</xsl:element>
										<xsl:element name="to">
											<xsl:attribute name="variable">GuardValue</xsl:attribute>
										</xsl:element>
									</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:element>
					</xsl:for-each>
					<xsl:for-each select="$transition/sacl:guard/sacl:invoke">
						<xsl:element name="invoke">
							<xsl:attribute name="name"><xsl:value-of select="$transition/sacl:guard/@name"/></xsl:attribute>
							<xsl:variable name="debugSourceId" select="../../@name"/>
							<xsl:attribute name="wpc:displayName">
							<xsl:text>SourceID=</xsl:text><xsl:value-of select="$debugSourceId"/><xsl:text> SourceType=Guard</xsl:text></xsl:attribute>
							<xsl:attribute name="id" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/"><xsl:value-of select="deploymentpkg:getDebugID($bsmxslhelper,$debugSourceId)"/></xsl:attribute>
							<xsl:attribute name="partnerLink">
								<xsl:value-of select="@reference"/>
							</xsl:attribute>
							<xsl:attribute name="portType">
								<xsl:value-of select="deploymentpkg:resolve-port-type($bsmxslhelper,.)"/>
							</xsl:attribute>
							<xsl:attribute name="operation"><xsl:value-of select="@operation"/></xsl:attribute>
							<genutil:trace message="Adding invoke of external operation"/>
							<xsl:element name="input" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
								<xsl:for-each select="sacl:input">
									<xsl:for-each select="sacl:parameter">
										<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
											<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
											<xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
										</xsl:element>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:element>
							<xsl:if test="deploymentpkg:is-two-way($bsmxslhelper,@reference,@operation)">
								<xsl:element name="output" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
									<xsl:for-each select="sacl:output">
										<xsl:for-each select="sacl:parameter">
											<xsl:element name="parameter" namespace="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/">
												<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
												<xsl:attribute name="variable"><xsl:value-of select="@variable"/></xsl:attribute>
											</xsl:element>
										</xsl:for-each>
									</xsl:for-each>
								</xsl:element>			
							</xsl:if>
						</xsl:element>							
					</xsl:for-each>
                    <!-- invert result if invert is set on the guard -->
                    <xsl:if test="$transition/sacl:guard/@invert = 'true'">
                        <xsl:call-template name="ExecuteJavaCode">
			                <xsl:with-param name="code">GuardValue = new Boolean(!GuardValue.booleanValue());</xsl:with-param>
                        </xsl:call-template>
                    </xsl:if>
					<xsl:call-template name="ExecuteJavaCode">
						<xsl:with-param name="code">com.ibm.wbiserver.statemachine.impl.V601RuntimeProxy.guardPostinvoke(this,"<xsl:value-of select="$transition/sacl:guard/@name"/>",GuardValue.booleanValue());</xsl:with-param>
					</xsl:call-template>					
				</xsl:element>
			</xsl:element>
			<xsl:element name="switch">
				<xsl:element name="case">
					<xsl:call-template name="addCondition">
						<xsl:with-param name="cond"><xsl:text>return(GuardValue != null &amp;&amp; GuardValue.equals(Boolean.TRUE));</xsl:text></xsl:with-param>
					</xsl:call-template>
                    <xsl:call-template name="addAssignSetNxt">
                       <xsl:with-param name="actTrans" select="$transition"/>
                    </xsl:call-template>
				</xsl:element>
				<xsl:element name="otherwise">
					<xsl:choose>
						<xsl:when test="$index &lt; count($transitions)">
								<xsl:call-template name="addStateTransitionCheck">
									<xsl:with-param name="trans" select="$transitions"/>
									<xsl:with-param name="pos" select="$index + 1"/>
									<xsl:with-param name="finalOtherwise" select="$finalOtherwise"/>
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$finalOtherwise"/>
							</xsl:otherwise>
						</xsl:choose>
				</xsl:element>
			</xsl:element>
			</xsl:element>			
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
